<?php
namespace Teknisa\PLA\Modules\Servico\Services;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ger04100Servico {
	protected $entityManager;
	
	public function __construct($entityManager) {
		$this->entityManager = $entityManager;
	}
	
	public function deletaConsumo($cdfilial, $cdservfili, $dtprocessa, $nrorg) {
		$this->deletaConsServ($cdfilial, $cdservfili, $dtprocessa, $nrorg);
		$this->deletaDiaSemCons($cdfilial, $cdservfili, $dtprocessa, $nrorg);
	}

	public function deletaConsServ($cdfilial, $cdservfili, $dtprocessa, $nrorg) {

		$sql = "DELETE FROM CONSSERV 
			WHERE (CDFILIAL = :CDFILIAL) AND
   				(CDSERVFILI = :CDSERVFILI)  AND
   				((IDTIPOCONS <> '9') OR 
   				((IDTIPOCONS = '9') AND (DTCONSSERV > :DATAPROC))) AND
				(NRORG = :NRORG)";

		$params = array(
		    'NRORG' => $nrorg,
            'CDFILIAL' => $cdfilial,
            'CDSERVFILI' => $cdservfili,
            'DATAPROC' => $dtprocessa,
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
	}

	public function deletaDiaSemCons($cdfilial, $cdservfili, $dtprocessa, $nrorg) {

		$sql = "DELETE FROM DIASEMCONS 
		WHERE (CDFILIAL  =:CDFILIAL) AND
   			(CDSERVFILI =:CDSERVFILI) AND
   			(DTSCONSSERV > :DATAPROC) AND
   			(NRORG = :NRORG)";

		$params = array(
		    'NRORG' => $nrorg,
            'CDFILIAL' => $cdfilial,
            'CDSERVFILI' => $cdservfili,
            'DATAPROC' => $dtprocessa,
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
	}

	public function deletaTodosTiposDePrato($cdfilial, $cdservfili, $dtrefcuspadr, $nrorg) {
		$sql = "DELETE FROM CUSTPADRTP 
			WHERE CDFILIAL = :CDFILIAL AND 
				NRORG = :NRORG AND 
				DTREFCUSPADR = :DTREFCUSPADR AND 
				CDSERVFILI = :CDSERVFILI";

		$params = array(
		    'NRORG' => $nrorg,
            'CDFILIAL' => $cdfilial,
            'CDSERVFILI' => $cdservfili,
            'DTREFCUSPADR' => $dtrefcuspadr,
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
	}

	public function deletaTodosPontosEntregaCliente($cdfilial, $cdservfili, $cdcliente, $nrorg) {
		$sql = "DELETE FROM DESTSRVCLI 
			WHERE CDFILIAL = :CDFILIAL AND 
				NRORG = :NRORG AND 
				CDCLIENTE = :CDCLIENTE AND 
				CDSERVFILI = :CDSERVFILI";

		$params = array(
		    'NRORG' => $nrorg,
            'CDFILIAL' => $cdfilial,
            'CDCLIENTE' => $cdcliente,
            'CDSERVFILI' => $cdservfili
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
	}
	
	public function exportConfigPadrao($cdFilialOrig, $cdServFiliOrig, $cdFilialDest, $cdServfiliDest){
		$sql = array("DELETE FROM CONFCARD
						WHERE ((:P_ALL_CDFILIDEST = 'T' )
						        OR ( CDFILIAL IN (:P_CDFILIDEST)))
						    AND ((:P_ALL_CDSERVFILIDEST = 'T' )
						        OR ( CDSERVFILI IN (:P_CDSERVFILIDEST) ))
						    AND (( CDFILIAL <>:P_CDFILIORIG )
						    	OR (CDFILIAL =:P_CDFILIORIG AND CDSERVFILI <>:P_CDSERVORIG))",
					
					"INSERT INTO CONFCARD
						(CDFILIAL, CDSERVFILI, NRSEQCNFCARD, CDTIPOPRAT,
						IDOPCCNFCARD, IDIMPCNFCARD, NRPAGCNFCARD, VRPERCOMCARD,
						NRORDCNFCARD, DTULTATUCFCA, DSOBSCNFCARD, DSCOMPLTP,
						IDTPPRATEXTR, IDVISUTPEXTR, IDTPPRATSEGP, IDTPPRATTERP,
						IDTPPRATQUAP, IDTPPRATQUIP, IDTPPRATSEXP, IDTPPRATSABP,
						IDTPPRATDOMP, IDTPPRATFERP, IDCONCNFCARD, CDCONTAINER,
						NRGRUPOEMB, IDRESERVAMYMENU)
					(SELECT SE.CDFILIAL, SE.CDSERVFILI, NRSEQCNFCARD, CDTIPOPRAT,
						IDOPCCNFCARD, IDIMPCNFCARD, NRPAGCNFCARD, VRPERCOMCARD,
						NRORDCNFCARD, DTULTATUCFCA, DSOBSCNFCARD, DSCOMPLTP,
						IDTPPRATEXTR, IDVISUTPEXTR, IDTPPRATSEGP, IDTPPRATTERP,
						IDTPPRATQUAP, IDTPPRATQUIP, IDTPPRATSEXP, IDTPPRATSABP,
						IDTPPRATDOMP, IDTPPRATFERP, IDCONCNFCARD, CDCONTAINER,
						NRGRUPOEMB, IDRESERVAMYMENU
					FROM CONFCARD CF, SERVICO SE
					WHERE (CF.CDFILIAL   = :P_CDFILIORIG)
						AND (CF.CDSERVFILI = :P_CDSERVORIG)
						AND ((:P_ALL_CDFILIDEST = 'T') 
							OR (SE.CDFILIAL IN (:P_CDFILIDEST)))
						AND ((:P_ALL_CDSERVFILIDEST = 'T') 
							OR (SE.CDSERVFILI IN (:P_CDSERVFILIDEST)))
						AND (( SE.CDFILIAL <>:P_CDFILIORIG ) 
							OR ( SE.CDFILIAL = :P_CDFILIORIG 
								AND SE.CDSERVFILI <>:P_CDSERVORIG )))");
				   
		$params = array(
			'P_CDSERVORIG' => $cdServFiliOrig,
            'P_CDFILIORIG' => $cdFilialOrig
		);
		
		// Correção de problema Oracle v<=10g.
		// Clausula IN só aceita no max 1000 registros.
		$cdFilialDestGroup = $cdFilialDest=='T' ? array() : array_chunk($cdFilialDest, 999);
		$cdServfiliDestGroup = $cdServfiliDest=='T' ? array() : array_chunk($cdServfiliDest, 999);
		
		
		foreach ($sql as $currentQuery){
			
			foreach ($cdFilialDestGroup as $index=>$codFilial) {
				$queryToExecute = $currentQuery;
				
				if($cdFilialDest!='T'){
					$this->setArrayOnQueryParameter($queryToExecute, $params, 'P_CDFILIDEST', $codFilial);
					$params['P_ALL_CDFILIDEST'] = false;
				} else {
					$params['P_CDFILIDEST'] = false;
					$params['P_ALL_CDFILIDEST'] = $codFilial;
				}
				
				if($cdServfiliDest!='T'){
					$this->setArrayOnQueryParameter($queryToExecute, $params, 'P_CDSERVFILIDEST', $cdServfiliDestGroup[$index]);
					$params['P_ALL_CDSERVFILIDEST'] = false;
				} else {
					$params['P_CDSERVFILIDEST'] = false;
					$params['P_ALL_CDSERVFILIDEST'] = $cdServfiliDestGroup[$index];
				}
				
				$queryToExecute = $this->entityManager->getConnection()->prepare($queryToExecute);
				$queryToExecute->execute($params);
			}	
		}
	}
	
	public function exportIncServUniDest($cdServFiliOrig, $cdFilialOrig, $cdFilialDest){
		
		$sql = "INSERT INTO SERVICO (IDOTIMIZADOR, CDFILIAL, CDSERVFILI, NMSERVICO, CDGRUPSERV,
				        HRINICATEN, QTCOMESTISEG, QTCOMESTITER, QTCOMESTIQUA,
				        QTCOMESTIQUI, QTCOMESTISEX, QTCOMESTISAB, QTCOMESTIDOM,
				        QTCOMESTIFER, QTCLIESTISEG, QTCLIESTITER, QTCLIESTIQUA,
				        QTCLIESTIQUI, QTCLIESTISEX, QTCLIESTISAB, QTCLIESTIDOM,
				        QTCLIESTIFER, QTFUNESTISEG, QTFUNESTITER, QTFUNESTIQUA,
				        QTFUNESTIQUI, QTFUNESTISEX, QTFUNESTISAB, QTFUNESTIDOM,
				        QTFUNESTIFER, QTDOAESTISEG, QTDOAESTITER, QTDOAESTIQUA,
				        QTDOAESTIQUI, QTDOAESTISEX, QTDOAESTISAB, QTDOAESTIDOM,
				        QTDOAESTIFER, CDPRODUTO, IDFATUSERV, IDSERVPADR, IDTIPOSERV,
				        CDROTATRANS, HRINICSERV, HRFINASERV, CDSERVDOS, IDSERVTRAN,
				        VRPESOCUSTO, DTULTATUSERV, CDSERPADDIE, IDTPSERVHOSP, 
				        IDCONSSERVCA, IDSERVPRINC, IDUTRETIPRAT, IDSERVATIV,
				        IDBLOQALTPRA, IDCONSCOMFAT, IDVLRVARDATA,
				        IDCARDDESCENTR, NMFANTASSERV, IDSERVFATSEP, IDBLOQCONFIXPER,
				        IDUTPRATRELAC, IDINDICADOR, IDCARDCONSUMIDORWEB,
				        HRENTREGA, NMSERVICOREDU)
				(SELECT T.IDOTIMIZADOR, S.CDFILIAL, :P_CDSERVORIG AS CDSERVFILI, T.NMSERVICO,
				    T.CDGRUPSERV, T.HRINICATEN, T.QTCOMESTISEG, T.QTCOMESTITER,
				    T.QTCOMESTIQUA, T.QTCOMESTIQUI, T.QTCOMESTISEX, T.QTCOMESTISAB,
				    T.QTCOMESTIDOM, T.QTCOMESTIFER, T.QTCLIESTISEG, T.QTCLIESTITER,
				    T.QTCLIESTIQUA, T.QTCLIESTIQUI, T.QTCLIESTISEX, T.QTCLIESTISAB,
				    T.QTCLIESTIDOM, T.QTCLIESTIFER, T.QTFUNESTISEG, T.QTFUNESTITER,
				    T.QTFUNESTIQUA, T.QTFUNESTIQUI, T.QTFUNESTISEX, T.QTFUNESTISAB,
				    T.QTFUNESTIDOM, T.QTFUNESTIFER, T.QTDOAESTISEG, T.QTDOAESTITER,
				    T.QTDOAESTIQUA, T.QTDOAESTIQUI, T.QTDOAESTISEX, T.QTDOAESTISAB,
				    T.QTDOAESTIDOM, T.QTDOAESTIFER, T.CDPRODUTO, T.IDFATUSERV,
				    T.IDSERVPADR, T.IDTIPOSERV, T.CDROTATRANS, T.HRINICSERV,
				    T.HRFINASERV, T.CDSERVDOS, T.IDSERVTRAN, T.VRPESOCUSTO,
				    T.DTULTATUSERV, T.CDSERPADDIE, T.IDTPSERVHOSP, T.IDCONSSERVCA,
				    T.IDSERVPRINC, T.IDUTRETIPRAT, T.IDSERVATIV, T.IDBLOQALTPRA,
				    T.IDCONSCOMFAT, T.IDVLRVARDATA, T.IDCARDDESCENTR,
				    T.NMFANTASSERV, T.IDSERVFATSEP, T.IDBLOQCONFIXPER, T.IDUTPRATRELAC,
				    T.IDINDICADOR, T.IDCARDCONSUMIDORWEB, T.HRENTREGA, T.NMSERVICOREDU
				  
				  FROM SERVICO T, 
					(SELECT F.CDFILIAL 
						FROM FILIAL F, SERVICO SE 
						WHERE F.CDFILIAL = SE.CDFILIAL (+) MINUS 
				        	SELECT FF.CDFILIAL
				        		FROM FILIAL FF, SERVICO SS
				        		WHERE
				            		FF.CDFILIAL = SS.CDFILIAL (+)
				            		AND SS.CDSERVFILI =:P_CDSERVORIG ) S
				  WHERE
				    ( T.CDFILIAL =:P_CDFILIORIG )
						AND ( T.CDSERVFILI =:P_CDSERVORIG )
				    	AND ((:P_ALL_CDFILIDEST = 'T') OR (S.CDFILIAL IN (:P_CDFILIDEST))))";

		$params = array(
		    'P_CDSERVORIG' => $cdServFiliOrig,
            'P_CDFILIORIG' => $cdFilialOrig
		);
		
		$cdFilialDestGroup = $cdFilialDest=='T' ? array() : array_chunk($cdFilialDest, 999);
		
		foreach ($cdFilialDestGroup as $index=>$codFilial) {
			$queryToExecute = $sql;
			
			if($cdFilialDest!='T'){
				$this->setArrayOnQueryParameter($queryToExecute, $params, 'P_CDFILIDEST', $codFilial);
				$params['P_ALL_CDFILIDEST'] = false;
			} else {
				$params['P_CDFILIDEST'] = false;
				$params['P_ALL_CDFILIDEST'] = $cdFilialDest;
			}
			
			$queryToExecute = $this->entityManager->getConnection()->prepare($queryToExecute);
			$queryToExecute->execute($params);
		}
	}
	
	public function exportParamsForm($cdServFiliOrig, $cdFilialOrig, $cdFilialDest, $cdServfiliDest, $servicoOrig){
		$sql = "UPDATE SERVICO
		   SET IDOTIMIZADOR = :IDOTIMIZADOR,
			   HRINICATEN   = :HRINICATEN,
		       CDROTATRANS  = :CDROTATRANS,
		       HRINICSERV   = :HRINICSERV,
		       HRFINASERV   = :HRFINASERV,
		       IDSERVATIV   = :IDSERVATIV,
		       HRENTREGA    = :HRENTREGA,
		       CDSERPADDIE  = :CDSERPADDIE,
		       IDTIPOSERV   = :IDTIPOSERV,
		       IDCONSSERVCA = :IDCONSSERVCA,
		       IDBLOQCONFIXPER = :IDBLOQCONFIXPER,
		       IDBLOQINCPRODRETIPLA = :IDBLOQINCPRODRETIPLA,
		       IDUTRETIPRAT = :IDUTRETIPRAT,
		       IDBLOQALTPRA = :IDBLOQALTPRA,
		       IDCONSCOMFAT = :IDCONSCOMFAT,
		       IDSERVPRINC  = :IDSERVPRINC,
		       IDSERVTRAN   = :IDSERVTRAN,
		       IDVLRVARDATA = :IDVLRVARDATA,
		       IDSERVFATSEP = :IDSERVFATSEP,
		       IDDISPOPEDIDOSERV = :IDDISPOPEDIDOSERV,
		       IDCARDDESCENTR = :IDCARDDESCENTR
			WHERE ((:P_ALL_CDFILIDEST = 'T') OR (CDFILIAL IN (:P_CDFILIDEST)))
				AND ((:P_ALL_CDSERVFILIDEST = 'T') OR (CDSERVFILI IN (:P_CDSERVFILIDEST)))
				AND (( CDFILIAL <>:P_CDFILIORIG ) 
    				OR ( CDFILIAL = :P_CDFILIORIG AND CDSERVFILI <>:P_CDSERVORIG ))";

		$params = array(
		    'P_CDSERVORIG' => $cdServFiliOrig,
            'P_CDFILIORIG' => $cdFilialOrig,
            'IDOTIMIZADOR' => $servicoOrig['IDOTIMIZADOR'],
            'HRINICATEN' => $servicoOrig['HRINICATEN'],
			'CDROTATRANS' => $servicoOrig['CDROTATRANS'],
			'HRINICSERV' => $servicoOrig['HRINICSERV'],
			'HRFINASERV' => $servicoOrig['HRFINASERV'],
			'IDSERVATIV' => $servicoOrig['IDSERVATIV'],
			'HRENTREGA' => $servicoOrig['HRENTREGA'],
			'CDSERPADDIE' => $servicoOrig['CDSERPADDIE'],
			'IDTIPOSERV' => $servicoOrig['IDTIPOSERV'],
			'IDCONSSERVCA' => $servicoOrig['IDCONSSERVCA'],
			'IDBLOQCONFIXPER' => $servicoOrig['IDBLOQCONFIXPER'],
			'IDBLOQINCPRODRETIPLA' => $servicoOrig['IDBLOQINCPRODRETIPLA'],
			'IDUTRETIPRAT' => $servicoOrig['IDUTRETIPRAT'],
			'IDBLOQALTPRA' => $servicoOrig['IDBLOQALTPRA'],
			'IDDISPOPEDIDOSERV' => $servicoOrig['IDDISPOPEDIDOSERV'],
			'IDCONSCOMFAT' => $servicoOrig['IDCONSCOMFAT'],
			'IDSERVPRINC' => $servicoOrig['IDSERVPRINC'],
			'IDSERVTRAN' => $servicoOrig['IDSERVTRAN'],
			'IDVLRVARDATA' => $servicoOrig['IDVLRVARDATA'],
			'IDSERVFATSEP' => $servicoOrig['IDSERVFATSEP'],
			'IDCARDDESCENTR' => $servicoOrig['IDCARDDESCENTR']
		);
		
		// Correção de problema Oracle v<=10g.
		// Clausula IN só aceita no max 1000 registros.
		$cdFilialDestGroup = $cdFilialDest=='T' ? array() : array_chunk($cdFilialDest, 999);
		$cdServfiliDestGroup = $cdServfiliDest=='T' ? array() : array_chunk($cdServfiliDest, 999);
		
		foreach ($cdFilialDestGroup as $index=>$codFilial) {
			$queryToExecute = $sql;
		
			if($cdFilialDest!='T'){
				$this->setArrayOnQueryParameter($queryToExecute, $params, 'P_CDFILIDEST', $codFilial);
				$params['P_ALL_CDFILIDEST'] = false;
			} else {
				$params['P_ALL_CDFILIDEST'] = $cdFilialDest;
			}
			
			if($cdServfiliDest!='T'){
				$this->setArrayOnQueryParameter($queryToExecute, $params, 'P_CDSERVFILIDEST', $cdServfiliDestGroup[$index]);
				$params['P_ALL_CDSERVFILIDEST'] = false;
			} else {
				$params['P_CDSERVFILIDEST'] = false;
				$params['P_ALL_CDSERVFILIDEST'] = $cdServfiliDest;
			}
			
			$queryToExecute = $this->entityManager->getConnection()->prepare($queryToExecute);
			$queryToExecute->execute($params);
			
		}
	}
	
	private function setArrayOnQueryParameter(&$query, &$paramsArray, $parameterName, $arrayToBind){
		$arrayParameterString = array();
		
		$arrayToBind = array_values($arrayToBind);
		
		foreach ($arrayToBind as $key => $value){
			
			array_push($arrayParameterString, ':'.$parameterName.'_'.$key);
			$paramsArray[$parameterName.'_'.$key] = $value;
			
		}
		
		$arrayParameterString = implode(', ', $arrayParameterString);
		
		$query = str_replace(':'.$parameterName, $arrayParameterString, $query);
	}
	
	public function autoIncludeServico($originData, $targetData){
		$this->entityManager->beginTransaction();
		try{
			$this->autoIncludeServicoQuery($originData, $targetData);
			$this->autoIncludeConfcardQuery($originData, $targetData);
			$this->autoIncludeCustpadrQuery($originData, $targetData);
			$this->autoIncludeCustpadrTpQuery($originData, $targetData);
			$this->autoIncludeTurnoservQuery($originData, $targetData);
			$this->entityManager->commit();
		}catch(\Exception $e){
			$this->entityManager->rollback();
			throw $e;
		}
	}
	
	private function autoIncludeServicoQuery($originData, $targetData){
		$sql = "INSERT INTO SERVICO
			    (CDSERVFILI, NMSERVICO, NMFANTASSERV, CDGRUPSERV, HRINICATEN, QTCOMESTISEG, QTCOMESTITER,
			       QTCOMESTIQUA, QTCOMESTIQUI, QTCOMESTISEX, QTCOMESTISAB, QTCOMESTIDOM,
			       QTCOMESTIFER, QTCLIESTISEG, QTCLIESTITER, QTCLIESTIQUA, QTCLIESTIQUI,
			       QTCLIESTISEX, QTCLIESTISAB, QTCLIESTIDOM, QTCLIESTIFER, QTFUNESTISEG,
			       QTFUNESTITER, QTFUNESTIQUA, QTFUNESTIQUI, QTFUNESTISEX, QTFUNESTISAB,
			       QTFUNESTIDOM, QTFUNESTIFER, QTDOAESTISEG, QTDOAESTITER, QTDOAESTIQUA,
			       QTDOAESTIQUI, QTDOAESTISEX, QTDOAESTISAB, QTDOAESTIDOM, QTDOAESTIFER,
			       CDPRODUTO, IDFATUSERV, IDTIPOSERV, CDFILIAL, CDROTATRANS,
			       HRINICSERV, HRFINASERV, IDSERVTRAN, VRPESOCUSTO, IDCONSSERVCA, IDSERVPRINC,
			       IDUTRETIPRAT, IDTPSERVHOSP, CDSERPADDIE, IDSERVATIV, IDBLOQALTPRA, IDCONSCOMFAT, IDVLRVARDATA,
			       CDSERVPREQUI, IDSERVFATSEP, IDBLOQCONFIXPER, HRENTREGA, NMSERVICOREDU) \n";
			       
		$params = array(
			"CDFILIAL" => $originData["CDFILIAL"],	
			"CDSERVFILI" => $originData["CDSERVFILI"],	
			"CDGRUPSERV" => $originData["CDGRUPSERV"]	
		);
		
		foreach ($targetData as $key => $value) {
			$cdservpadr = (verificaComandoInvalido($value['CDSERVPADR'])) ? '': $value['CDSERVPADR'];
			$nmservpadr = (verificaComandoInvalido($value['NMSERVPADR'])) ? '' : $value['NMSERVPADR'];
			$sqlPart = "SELECT '".$cdservpadr."' AS CDSERVFILI, '".$nmservpadr."' AS NMSERVICO, NULL AS 
						   NMFANTASSERV, :CDGRUPSERV AS CDGRUPSERV, HRINICATEN, QTCOMESTISEG, QTCOMESTITER,
					       QTCOMESTIQUA, QTCOMESTIQUI, QTCOMESTISEX, QTCOMESTISAB, QTCOMESTIDOM,
					       QTCOMESTIFER, QTCLIESTISEG, QTCLIESTITER, QTCLIESTIQUA, QTCLIESTIQUI,
					       QTCLIESTISEX, QTCLIESTISAB, QTCLIESTIDOM, QTCLIESTIFER, QTFUNESTISEG,
					       QTFUNESTITER, QTFUNESTIQUA, QTFUNESTIQUI, QTFUNESTISEX, QTFUNESTISAB,
					       QTFUNESTIDOM, QTFUNESTIFER, QTDOAESTISEG, QTDOAESTITER, QTDOAESTIQUA,
					       QTDOAESTIQUI, QTDOAESTISEX, QTDOAESTISAB, QTDOAESTIDOM, QTDOAESTIFER,
					       CDPRODUTO, IDFATUSERV, IDTIPOSERV, :CDFILIAL AS CDFILIAL, CDROTATRANS,
					       HRINICSERV, HRFINASERV, IDSERVTRAN, VRPESOCUSTO, IDCONSSERVCA, IDSERVPRINC,
					       IDUTRETIPRAT, IDTPSERVHOSP, CDSERPADDIE, IDSERVATIV, IDBLOQALTPRA, IDCONSCOMFAT, IDVLRVARDATA,
					       CDSERVPREQUI, IDSERVFATSEP, IDBLOQCONFIXPER, HRENTREGA, '".$nmservpadr."' AS NMSERVICOREDU
					    FROM SERVICO
					    WHERE CDFILIAL = :CDFILIAL AND CDSERVFILI = :CDSERVFILI \n";
			
			if($key>0){
				$sqlPart = "UNION ALL ".$sqlPart;
			}
			
			$sql .= $sqlPart;
		}
		
		$query = $this->entityManager->getConnection()->prepare($sql);
		$query->execute($params);
	}
	
	private function autoIncludeConfcardQuery($originData, $targetData){
		$sql = "INSERT INTO CONFCARD
			    (CDFILIAL, CDSERVFILI, NRORDCNFCARD, NRSEQCNFCARD, CDTIPOPRAT, IDOPCCNFCARD, IDIMPCNFCARD, 
			    NRPAGCNFCARD, VRPERCOMCARD, DSOBSCNFCARD, DSCOMPLTP, IDTPPRATEXTR, IDVISUTPEXTR, IDCONCNFCARD,
			    IDTPPRATSEGP, IDTPPRATTERP, IDTPPRATQUAP, IDTPPRATQUIP, IDTPPRATSEXP, IDTPPRATSABP, IDTPPRATDOMP, 
			    IDTPPRATFERP, CDCONTAINER, NRGRUPOEMB)\n";
			       
		$params = array(
			"CDFILIAL" => $originData["CDFILIAL"],	
			"CDSERVFILI" => $originData["CDSERVFILI"]	
		);
		
		foreach ($targetData as $key => $value) {
			$cdservpadr = (verificaComandoInvalido($value['CDSERVPADR'])) ? '': $value['CDSERVPADR'];
			$sqlPart = "SELECT
			    :CDFILIAL AS CDFILIAL, '".$cdservpadr."' AS CDSERVFILI, NRORDCNFCARD, NRSEQCNFCARD, CDTIPOPRAT, IDOPCCNFCARD, IDIMPCNFCARD,
			    NRPAGCNFCARD, VRPERCOMCARD, DSOBSCNFCARD, DSCOMPLTP, IDTPPRATEXTR, IDVISUTPEXTR, IDCONCNFCARD,
			    IDTPPRATSEGP, IDTPPRATTERP, IDTPPRATQUAP, IDTPPRATQUIP, IDTPPRATSEXP, IDTPPRATSABP, IDTPPRATDOMP, IDTPPRATFERP, CDCONTAINER, NRGRUPOEMB
			    FROM CONFCARD
			    WHERE CDFILIAL = :CDFILIAL AND CDSERVFILI = :CDSERVFILI\n";
			
			if($key>0){
				$sqlPart = "UNION ALL ".$sqlPart;
			}
			
			$sql .= $sqlPart;
		}
		
		$query = $this->entityManager->getConnection()->prepare($sql);
		$query->execute($params);
	}
	
	private function autoIncludeCustpadrQuery($originData, $targetData){
		$sql = "INSERT INTO CUSTPADR (CDFILIAL, CDSERVFILI, DTREFCUSPADR, VRCUSTPADR)\n";
			       
		$params = array(
			"CDFILIAL" => $originData["CDFILIAL"],	
			"CDSERVFILI" => $originData["CDSERVFILI"]	
		);
		
		foreach ($targetData as $key => $value) {
			$cdservpadr = (verificaComandoInvalido($value['CDSERVPADR'])) ? '': $value['CDSERVPADR'];
			$sqlPart = "SELECT :CDFILIAL AS CDFILIAL, '".$cdservpadr."' AS CDSERVFILI, DTREFCUSPADR, VRCUSTPADR
				    FROM CUSTPADR
				    WHERE CDFILIAL = :CDFILIAL AND CDSERVFILI = :CDSERVFILI\n";
			
			if($key>0){
				$sqlPart = "UNION ALL ".$sqlPart;
			}
			
			$sql .= $sqlPart;
		}
		
		$query = $this->entityManager->getConnection()->prepare($sql);
		$query->execute($params);
	}
	
	private function autoIncludeCustpadrTpQuery($originData, $targetData){
		$sql = "INSERT INTO CUSTPADRTP
    		(CDFILIAL, CDSERVFILI, CDTIPOPRAT, VRCUSTPADRTP, DTREFCUSPADR)\n";
			       
		$params = array(
			"CDFILIAL" => $originData["CDFILIAL"],
			"CDSERVFILI" => $originData["CDSERVFILI"]	
		);
		
		foreach ($targetData as $key => $value) {
			$cdservpadr = (verificaComandoInvalido($value['CDSERVPADR'])) ? '': $value['CDSERVPADR'];
			$sqlPart = "SELECT :CDFILIAL AS CDFILIAL, '".$cdservpadr."' AS CDSERVFILI, CDTIPOPRAT, VRCUSTPADRTP, DTREFCUSPADR
			    FROM CUSTPADRTP
			    WHERE CDFILIAL = :CDFILIAL AND CDSERVFILI = :CDSERVFILI\n";
			
			if($key>0){
				$sqlPart = "UNION ALL ".$sqlPart;
			}
			
			$sql .= $sqlPart;
		}
		
		$query = $this->entityManager->getConnection()->prepare($sql);
		$query->execute($params);
	}
	
	private function autoIncludeTurnoservQuery($originData, $targetData){
		$sql = "INSERT INTO TURNOSERV
		    (CDTURNO, NMTURNO, QTCOMESTTSEG, QTCOMESTTTER, QTCOMESTTQUA, QTCOMESTTQUI,
		    QTCOMESTTSEX, QTCOMESTTSAB, QTCOMESTTDOM, QTCOMESTTFER, CDSERVFILI,
		    CDFILIAL)\n";
			       
		$params = array(
			"CDFILIAL" => $originData["CDFILIAL"],	
			"CDSERVFILI" => $originData["CDSERVFILI"]	
		);
		
		foreach ($targetData as $key => $value) {
			$cdservpadr = (verificaComandoInvalido($value['CDSERVPADR'])) ? '': $value['CDSERVPADR'];
			$sqlPart = "SELECT CDTURNO, NMTURNO, QTCOMESTTSEG, QTCOMESTTTER, QTCOMESTTQUA, QTCOMESTTQUI,
			    QTCOMESTTSEX, QTCOMESTTSAB, QTCOMESTTDOM, QTCOMESTTFER, '".$cdservpadr."' AS CDSERVFILI,
			    :CDFILIAL AS CDFILIAL
			    FROM TURNOSERV
			    WHERE CDFILIAL = :CDFILIAL AND CDSERVFILI = :CDSERVFILI\n";
			
			if($key>0){
				$sqlPart = "UNION ALL ".$sqlPart;
			}
			
			$sql .= $sqlPart;
		}
		
		$query = $this->entityManager->getConnection()->prepare($sql);
		$query->execute($params);
	}
	
	public function getParamGeralIdutcardpadr(){
		$sql = "SELECT
                    NVL(IDUTCARDPADR, 'N') AS IDUTCARDPADR
                FROM
                    PARAMGERAL";
		
		$query = $this->entityManager->getConnection()->prepare($sql);
		$query->execute();
		return $query->fetchAll();
	}
	
	public function exportaComensalCardapio($params){
        $connection = $this->entityManager->getConnection();
        $procedure = new StoredProcedure($connection, 'EXPORTA_COMENSAIS');
        $procedure->addParam(new Param('P_CDFILIAL',   Param::PARAM_INPUT, $params['CDFILIAL'],   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDSERVFILI', Param::PARAM_INPUT, $params['CDSERVFILI'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL',  Param::PARAM_INPUT, $params['DTINICIAL'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL',    Param::PARAM_INPUT, $params['DTFINAL'],    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDINSERIR',  Param::PARAM_INPUT, $params['IDINSERIR'],  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $params['CDOPERADOR'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_LDIETA',     Param::PARAM_INPUT, $params['LDIETA'],     Param::PARAM_TYPE_STR));
        $procedure->execute();
	}
	
	public function deletaCustoPadrao($cdfilial, $cdservfili, $dtrefcuspadr, $nrorg) {
		$sql = "DELETE FROM CUSTPADR 
			WHERE CDFILIAL = :CDFILIAL AND 
				NRORG = :NRORG AND 
				DTREFCUSPADR = :DTREFCUSPADR AND 
				CDSERVFILI = :CDSERVFILI";

		$params = array(
		    'NRORG' => $nrorg,
            'CDFILIAL' => $cdfilial,
            'CDSERVFILI' => $cdservfili,
            'DTREFCUSPADR' => $dtrefcuspadr,
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
	}
	
	public function insereCustoPadrao($row){
		$sql = "INSERT INTO CUSTPADRTP
			   (CDFILIAL, CDSERVFILI, DTREFCUSPADR, CDTIPOPRAT, VRCUSTPADRTP)
			   (SELECT  A.CDFILIAL     AS CDFILIAL,
					    A.CDSERVFILI   AS CDSERVFILI,
					    :DTREFCUSPADR AS DTREFCUSPADR,
					    A.CDTIPOPRAT   AS CDTIPOPRAT,
					    DECODE(B.VRCUSTOTOTAL, :VRCUSTPADRTP, A.VRCUSTPADRTPANT, ROUND((A.VRCUSTPADRTPANT / B.VRCUSTOTOTAL * :VRCUSTPADRTP), 5 )) AS VRCUSTPADRTP
					FROM
					    ( SELECT
					            CDFILIAL,
					            CDSERVFILI,
					            CDTIPOPRAT,
					            VRCUSTPADRTP AS VRCUSTPADRTPANT
					        FROM
					            CUSTPADRTP
					        WHERE
					            ( DTREFCUSPADR = (
					                SELECT MAX(DTREFCUSPADR) AS DTREFCUSPADR
					                  FROM CUSTPADRTP
					                WHERE
					                    ( DTREFCUSPADR <= :P_DTINI )
					                    AND ( CDFILIAL = :P_CDFILIAL )
					                    AND ( CDSERVFILI = :P_CDSERVFILI )
					            ) )
					            AND ( CDFILIAL = :P_CDFILIAL )
					            AND ( CDSERVFILI = :P_CDSERVFILI )
					    ) A,
					    (
					        SELECT SUM(VRCUSTPADRTP) AS VRCUSTOTOTAL
					          FROM CUSTPADRTP
					        WHERE
					            ( DTREFCUSPADR = (
					                SELECT MAX(DTREFCUSPADR) AS DTREFCUSPADR
					                  FROM CUSTPADRTP
					                WHERE
					                    ( DTREFCUSPADR <= :P_DTINI )
					                    AND ( CDFILIAL = :P_CDFILIAL )
					                    AND ( CDSERVFILI = :P_CDSERVFILI )
					            ) )
					            AND ( CDFILIAL = :P_CDFILIAL )
					            AND ( CDSERVFILI = :P_CDSERVFILI )
					    ) B)";
		$params = array(
			'P_DTINI'      => $row['DTINICIAL'],
			'P_CDFILIAL'   => $row['CDFILIAL'],
			'P_CDSERVFILI' => $row['CDSERVFILI'],
			'DTREFCUSPADR' => $row['DTREFCUSPADR'],
			'VRCUSTPADRTP' => $row['VRCUSTPADR']
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
	}
	
	public function retornaCustosComData($row){
		$sql = "SELECT
				    NVL(CUSTO.CDFILIAL, :CDFILIAL) AS CDFILIAL,
				    NVL(CUSTO.CDSERVFILI, :CDSERVFILI) AS CDSERVFILI,
				    DT.DTMES          AS DTREFCUSPADR,
				    NVL(VRCUSTPADR, :VRCUSTPADR) AS VRCUSTPADR,
				    CASE
				        WHEN CDFILIAL IS NULL THEN 'N'
				        ELSE
				            'S'
				    END AS POSSUI_CUSTO
				FROM
				    ( SELECT *
				        FROM CUSTPADR
				        WHERE
				            CDFILIAL = :CDFILIAL
				            AND CDSERVFILI = :CDSERVFILI
				    ) CUSTO RIGHT JOIN (
				        SELECT DISTINCT DTMES
						FROM DATA
				        WHERE
				            DTMES BETWEEN :DTINICIAL AND :DTFINAL
				    )         DT ON DT.DTMES = CUSTO.DTREFCUSPADR";
				    
		$params = array(
			'DTFINAL'    => $row['DTFINAL'],
			'CDFILIAL'   => $row['CDFILIAL'],
			'CDSERVFILI' => $row['CDSERVFILI'],
			'DTINICIAL'  => $row['DTINICIAL'],
			'VRCUSTPADR' => $row['VRCUSTPADR']
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
	}
	
	public function deletaEmbalagens($row) {

		$sql = "DELETE FROM
				    CNFDISTEMBSERV
				WHERE
				    CDFILIAL = :CDFILIAL
				    AND CDSERVFILI = :CDSERVFILI
				    AND NRORG = :NRORG";

		$params = array(
			'NRORG'      => $row['NRORG'],
			'CDFILIAL'   => $row['CDFILIAL'],
			'CDSERVFILI' => $row['CDSERVFILI']
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
	}
	
	public function coletaComensaisTotais($row){
		$sql = "
				SELECT
				'COMENSAIS_TOTAIS_CLIENTES' AS TIPO,
				NVL(QTCLIESTISEG, 0) AS QTCLIESTISEG,
				NVL(QTCLIESTITER, 0) AS QTCLIESTITER,
				NVL(QTCLIESTIQUA, 0) AS QTCLIESTIQUA,
				NVL(QTCLIESTIQUI, 0) AS QTCLIESTIQUI,
				NVL(QTCLIESTISEX, 0) AS QTCLIESTISEX,
				NVL(QTCLIESTISAB, 0) AS QTCLIESTISAB,
				NVL(QTCLIESTIDOM, 0) AS QTCLIESTIDOM,
				NVL(QTCLIESTIFER, 0) AS QTCLIESTIFER
				FROM SERVICO
				WHERE CDFILIAL = :P_CDFILIAL
				  AND CDSERVFILI = :P_CDSERVFILI
				
				UNION ALL
				
				SELECT
				'COMENSAIS_TOTAIS' AS TIPO,
				NVL(QTCOMESTISEG, 0) AS QTCOMESTISEG,
				NVL(QTCOMESTITER, 0) AS QTCOMESTITER,
				NVL(QTCOMESTIQUA, 0) AS QTCOMESTIQUA,
				NVL(QTCOMESTIQUI, 0) AS QTCOMESTIQUI,
				NVL(QTCOMESTISEX, 0) AS QTCOMESTISEX,
				NVL(QTCOMESTISAB, 0) AS QTCOMESTISAB,
				NVL(QTCOMESTIDOM, 0) AS QTCOMESTIDOM,
				NVL(QTCOMESTIFER, 0) AS QTCOMESTIFER
				FROM SERVICO
				WHERE CDFILIAL = :P_CDFILIAL
				  AND CDSERVFILI = :P_CDSERVFILI
				
				UNION ALL
				
				SELECT 
				'TURNOS' AS TIPO,
				SUM(NVL(QTCOMESTTSEG, 0)) AS QTCOMESTTSEG,
				SUM(NVL(QTCOMESTTTER, 0)) AS QTCOMESTTTER,
				SUM(NVL(QTCOMESTTQUA, 0)) AS QTCOMESTTQUA,
				SUM(NVL(QTCOMESTTQUI, 0)) AS QTCOMESTTQUI,
				SUM(NVL(QTCOMESTTSEX, 0)) AS QTCOMESTTSEX,
				SUM(NVL(QTCOMESTTSAB, 0)) AS QTCOMESTTSAB,
				SUM(NVL(QTCOMESTTDOM, 0)) AS QTCOMESTTDOM,
				SUM(NVL(QTCOMESTTFER, 0)) AS QTCOMESTTFER
				FROM TURNOSERV
				WHERE CDFILIAL = :P_CDFILIAL
				  AND CDSERVFILI = :P_CDSERVFILI
				GROUP BY CDFILIAL, CDSERVFILI
				
				UNION ALL
				
				SELECT 
				'PONTOS_ENTREGA' AS TIPO,
				SUM(NVL(QTCOESTCSSEG, 0)) AS QTCOESTCSSEG,
				SUM(NVL(QTCOESTCSTER, 0)) AS QTCOESTCSTER,
				SUM(NVL(QTCOESTCSQUA, 0)) AS QTCOESTCSQUA,
				SUM(NVL(QTCOESTCSQUI, 0)) AS QTCOESTCSQUI,
				SUM(NVL(QTCOESTCSSEX, 0)) AS QTCOESTCSSEX,
				SUM(NVL(QTCOESTCSSAB, 0)) AS QTCOESTCSSAB,
				SUM(NVL(QTCOESTCSDOM, 0)) AS QTCOESTCSDOM,
				SUM(NVL(QTCOESTCSFER, 0)) AS QTCOESTCSFER
				FROM DESTSRVCLI
				WHERE CDFILIAL = :P_CDFILIAL
				  AND CDSERVFILI = :P_CDSERVFILI
				GROUP BY CDFILIAL, CDSERVFILI";
				    
		$params = array(
			'P_CDFILIAL'   => $row['CDFILIAL'],
			'P_CDSERVFILI' => $row['CDSERVFILI']
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
	}
	
	public function retornaDiasSemana($row){
		$sql = "SELECT DISTINCT TO_CHAR(DTDATA, 'D') AS DIA_SEMANA
				  FROM DATA D
				WHERE DTDATA BETWEEN :P_DATAINI AND :P_DATAFIN
				
				UNION ALL
				
				SELECT DISTINCT '8' AS DIA_SEMANA
				  FROM FERICARD F
				WHERE CDFILIAL = :P_CDFILIAL
				   AND DTFERICARD BETWEEN :P_DATAINI AND :P_DATAFIN
				   AND (SELECT NVL(MAX(IDCARDIAUTIL), 'N') FROM PARAMPLANEJA WHERE CDFILIAL = :P_CDFILIAL) = 'N'
				   AND NOT EXISTS(SELECT 1 FROM FERIFILI WHERE CDFILIAL = :P_CDFILIAL AND DTFERIFILI = F.DTFERICARD)";
				    
		$params = array(
			'P_CDFILIAL'   => $row['CDFILIAL'],
			'P_DATAINI' => $row['DTINICIAL'],
			'P_DATAFIN' => $row['DTFINAL']
		);

		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
	}
	
	private function verificaComandoInvalido($comando){
        $pattern ='/\b(SELECT|INSERT|UPDATE|DELETE|MERGE|CREATE|GRANT|DROP).{1,}(FROM|SET|TABLE|TRIGGER|DATABASE|PROCEDURE|FUNCTION|VIEW|JOB)\b/i';
        return preg_match_all($pattern, $comando, $matches);
    }
}